//
//  View1.m
//  Jun21
//
//  Created by Nick McConnell on 6/17/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "View1.h"
#import "SmallView.h"

@implementation View1

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
    }
    string1 = @"Default View"; // initialize the instance value of the text
    isShowGrahpics = NO; // by default don't show the grahpics
    return self;
}

- (id)initWithFrame:(CGRect)frame withString:(NSString *) s withGraphics:(BOOL) g

{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
    
    string1 = s;
    maincolor = 0.2;
    isShowGrahpics = g;
        lastview=1;
   
    
    CGRect r1 = CGRectMake(50, 160, 100, 20);   
    smallview1 = [[SmallView alloc] initWithFrame: r1];
    [self addSubview: smallview1];
    smallview1.backgroundColor = [UIColor colorWithRed: 0.2 green: 1 blue: 0.0 alpha: 1.0];
    
   
    CGRect r2 = CGRectMake(50, 150, 100, 20);   
    smallview2 = [[SmallView alloc] initWithFrame: r2];
    [self addSubview: smallview2];
    smallview2.backgroundColor = [UIColor colorWithRed: 0.2 green: 0.1 blue: 1.0 alpha: 1.0];
    }
    
    NSString *string = @"Click to remove keyboard";
    UIFont *font = [UIFont systemFontOfSize: 16];
    
    CGSize size = [string sizeWithFont: font]; // neat trick to get the right sizing
    CGRect r3 = CGRectMake(50,120,size.width,size.height);
    
    label1 = [[UILabel alloc] initWithFrame: r3];
    label1.backgroundColor = [UIColor yellowColor];
    label1.font = font;
    label1.text = string;
    [self addSubview: label1];
    
    //TEXT VIEW AREA
    CGRect r4 = CGRectMake(50, 5, 250, 100);
    textView1 = [[UITextView alloc] initWithFrame: r4];
    textView1.backgroundColor = [UIColor whiteColor];
    textView1.textColor = [UIColor blackColor];
    textView1.font = [UIFont fontWithName: @"Times New Roman" size: 15.75];
    textView1.editable = YES;	//Don't pop up a keyboard.
    
    textView1.text =
    @"Two households, both alike in dignity,\n"
    @"In fair Verona, where we lay our scene,\n"
    @"From ancient grudge break to new mutiny,\n"
    @"Where civil blood makes civil hands unclean.\n\n"
    
    @"From forth the fatal loins of these two foes\n"
    @"A pair of star-cross’d lovers take their life;\n"
    @"Whose misadventur'd piteous overthrows\n"
    @"Doth with their death bury their parents’ strife.\n\n"
    
    @"The fearful passage of their death-mark’d love,\n"
    @"And the continuance of their parents’ rage,\n"
    @"Which, but their children’s end, naught could remove,\n"
    @"Is now the two hours’ traffic of our stage;\n\n"
    
    @"The which if you with patient ears attend,\n"
    @"What here shall miss, our toil shall strive to mend.\n\n";
    
    textView1.text = [textView1.text stringByAppendingFormat:
                     @"\t\tRomeo and Juliet, Prologue %d–%d", 1, 14
                     ];
    
    [self addSubview: textView1];
    
    return self;
    
    }


- (void) pulseup
{
    maincolor = (maincolor + 0.15);
    
    if (maincolor > 1)
        {maincolor = 1;}
    if (maincolor < 0)
        {maincolor = 0;}
    
    NSLog(@"Up: Main color = %g",maincolor);
    
    [self setNeedsDisplay];

    
 
        return;
}

- (void) pulsedown
{
maincolor = (maincolor - 0.1);

if (maincolor > 1)
{maincolor = 1;}
if (maincolor < 0)
{maincolor = 0;}

NSLog(@"Down: Main color = %g",maincolor);

[self setNeedsDisplay];

return;

}


//Tap the screen methods

- (void) touchesEnded: (NSSet *) touches withEvent: (UIEvent *) event {	
	UITouch *touch = [touches anyObject];
	
	if (touch.tapCount == 1) {
		
        //pulse up, then a little down
        SEL selu = @selector(pulseup);
        [self performSelector: selu withObject: nil afterDelay: 0.05];
        [self performSelector: selu withObject: nil afterDelay: 0.1];
        [self performSelector: selu withObject: nil afterDelay: 0.15];
        [self performSelector: selu withObject: nil afterDelay: 0.2];
        
        SEL seld = @selector(pulsedown);
        [self performSelector: seld withObject: nil afterDelay: 0.25];
        [self performSelector: seld withObject: nil afterDelay: 0.3];
        [self performSelector: seld withObject: nil afterDelay: 0.35];
        [self performSelector: seld withObject: nil afterDelay: 0.4];
        
    } 
    else if (touch.tapCount == 2) {
		[self pulsedown];
     
    
    
	}
}


- (void) touchesBegan: (NSSet *) touches withEvent: (UIEvent *) event {
	UITouch *touch = [touches anyObject];
	
	if (touch.tapCount == 2) {
		[NSObject cancelPreviousPerformRequestsWithTarget: self];
	}
    
    if (touch.tapCount == 1) {
        
        [textView1 resignFirstResponder]; // get rid of the keyboard by default
        
        if (lastview==1) {
        [UIView animateWithDuration: 1.0
                              delay: 0.0
                            options: UIViewAnimationOptionCurveEaseInOut
                         animations: ^{
                             //This block describes what the animation should do.
                             smallview1.center = [[touches anyObject] locationInView: self];
                         }
                         completion: NULL
         ];
            lastview=2;
        }

        else {
        
            [UIView animateWithDuration: 1.0
                                  delay: 0.0
                                options: UIViewAnimationOptionCurveEaseInOut
                             animations: ^{
                                 //This block describes what the animation should do.
                                 smallview2.center = [[touches anyObject] locationInView: self];
                             }
                             completion: NULL
             ];
            lastview=1;

            
        }
        
        
    }
}


// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void) drawRect: (CGRect) rect
{
    
    CGContextRef c = UIGraphicsGetCurrentContext();
  
    
    //SHOW VIEW TEXT
    //Make the text Glow
    float glowWidth = 5.0;
    float colorValues[] = { 1, 1, 0.7, 1.0 };
    CGColorSpaceRef colorSpace = CGColorSpaceCreateDeviceRGB();
    CGColorRef glowColor = CGColorCreate( colorSpace, colorValues );
    CGContextSetShadowWithColor( c, CGSizeZero, glowWidth, glowColor );

    
    [string1 drawAtPoint: CGPointZero
                withFont: [UIFont systemFontOfSize: 20]
     ];
    
        
    // SHOW GRAPHICS if required
    if (isShowGrahpics) {
     CGRect bounds = self.bounds;
     
     CGFloat radius = .3 * bounds.size.width;    //in pixels
     
     CGRect r = CGRectMake(
     -radius,
     -radius,
     2 * radius,
     2 * radius
     );
     
     
     CGContextTranslateCTM(c, bounds.size.width / 2, bounds.size.height / 2);
     
     CGContextScaleCTM(c, 0.5, -0.5);
     
     CGContextBeginPath(c); //unnecessary here: the path is already empty.
     CGContextAddEllipseInRect(c,r);
     CGContextSetRGBFillColor(c, maincolor, 0.0, 0.0, 1.0);    //red, opaque
     CGContextFillPath(c);
     
  /* OLD GRAPHICS   
         int i=0;
     
     for (i = 0; i < 40; i++)
     {
     CGRect r = CGRectMake(80,80,100,110);
     CGContextBeginPath(c); //unnecessary here: the path is already empty.
     CGContextRotateCTM(c, M_PI/10); //90 degrees clockwise
     CGContextAddEllipseInRect(c,r);
     CGContextSetRGBFillColor(c, 0.1, maincolor, 0.2, 0.2); //green, opaque
     CGContextFillPath(c);
     
     }
        
        //spiral
        for (i = 0; i < 400; i++)
        {
            CGRect r = CGRectMake(i*0.7,i*0.7,2+(i*0.1),2+(i*0.1));
            CGContextRef c = UIGraphicsGetCurrentContext();
            CGContextBeginPath(c); //unnecessary here: the path is already empty.
            CGContextRotateCTM(c, M_PI/30); //marginally rotate
            CGContextAddEllipseInRect(c,r);
            CGContextSetRGBFillColor(c, 0, 0, maincolor, 1);  
            CGContextFillPath(c);
            
        }
   
   */
        

    }
    
    
    
    
    

    
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
    // Drawing code
}
*/

@end
