//
//  Jun21AppDelegate.m
//  Jun21
//
//  Created by Devon McConnell on 6/17/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "Jun28AppDelegate.h"
#import "View1.h"
#import <QuartzCore/QuartzCore.h>

@implementation Jun28AppDelegate

@synthesize window = _window;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    
    // Override point for customization after application launch.
    UIScreen *screen = [UIScreen mainScreen];
    
    CGRect applicationFrame = screen.applicationFrame;
    CGRect bounds = screen.bounds;

    self.window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];

    NSLog(@"The screen dimensions %g, %g, %g, %g", bounds.origin.x,bounds.origin.y,bounds.size.width,bounds.size.height);
    
    /*
    //first view
    CGRect small1 = CGRectMake(0, 20, applicationFrame.size.width, 30);   
    view1_top= [[View1 alloc] initWithFrame: small1];
    //self.window = [[UIWindow alloc] initWithFrame: small1];
    [self.window addSubview: view1_top];
    view1_top.backgroundColor = [UIColor colorWithRed: 0.2 green: 0.5 blue: 0.2 alpha: 1.0];

    //second view
    CGRect small2 = CGRectMake(0, 55, applicationFrame.size.width, 30);   
    view1_middle = [[View1 alloc] initWithFrame:small2 withString:@"Second View" withGraphics:NO];
    [self.window addSubview: view1_middle];
    view1_middle.backgroundColor = [UIColor colorWithRed: 0.2 green: 0.2 blue: 0.5 alpha: 1.0];
    
    */
    
    //third view
    CGRect bigRect = CGRectMake(0, 100, applicationFrame.size.width, 300);   
    view1_big = [[View1 alloc] initWithFrame:bigRect withString:@"Graphics View" withGraphics:YES];
    [self.window addSubview: view1_big];
    view1_big.backgroundColor = [UIColor colorWithRed: 0.2 green: 0.1 blue: 0.0 alpha: 1.0];
 
    

    self.window.backgroundColor = [UIColor blackColor];
    
    [self.window makeKeyAndVisible];
    
    //[view1_big pulseup];
    
    //NOW TAKE A SNAPSHOT!
    /* WE DON'T RUN THIS EVERYTIME
     
    NSLog(@"Snapshot attempt");
    
    UIGraphicsBeginImageContext(self.window.bounds.size);
    [self.window.layer renderInContext: UIGraphicsGetCurrentContext()];
    UIImage *image = UIGraphicsGetImageFromCurrentImageContext();
	UIGraphicsEndImageContext();
    
	if (image == nil) {
		NSLog(@"UIGraphicsGetImageFromCurrentImageContext failed");
		return YES;
	}
    
	NSData *d = UIImagePNGRepresentation(image);
	if (d == nil) {
		NSLog(@"UIImagePNGRepresentation failed");
		return YES;
	}
    
	NSString *fileName = [NSString stringWithFormat:
                          @"%@/nicksnapshot.png", NSHomeDirectory()];
    
    NSLog(@"Will place here %@",fileName);
    
	if (![d writeToFile: fileName atomically: NO]) {
		NSLog(@"writeToFile:atomically: failed");
		return YES;
        
	}
    */
    
    
    //ADD SOME MUSIC
    NSBundle *bundle = [NSBundle mainBundle];
    if (bundle == nil) {
        NSLog(@"could not get the main bundle");
        return YES;
    }
    
    //The path is the filename.
    NSString *path =
    [bundle pathForResource: @"jam" ofType: @"mp3"];
    if (path == nil) {
        NSLog(@"could not get the path");
        return YES;
    }
    NSLog(@"path == \"%@\"", path);
    
    NSURL *url = [NSURL fileURLWithPath: path isDirectory: NO];
    NSLog(@"url == \"%@\"", url);
    
    NSError *error = nil;
    player = [[AVAudioPlayer alloc]
              initWithContentsOfURL: url error: &error];
    if (player == nil) {
        NSLog(@"error == %@", error);
        return YES;
    }
    
    player.volume = 1.0;		//the default
    player.numberOfLoops = 0;	//negative number for infinite loop
    /*
     NSLog(@"player.numberOfChannels == %u",
     player.numberOfChannels); //mono or stereo
     */
    
    if (![player prepareToPlay]) {
        NSLog(@"could not prepare to play");
        return YES;
    }
    
    if (![player play]) {
        NSLog(@"could not play");
    }
    
    return YES;
    
    

}

- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

@end
